# Href Lang Exchange

## Installation

Install this modules like any other Drupal modules.
It consists of 3 modules.

### href_lang_exchange
- dependencies:
    - field
    - jsonapi

### href_lang_entity_manager
- dependencies:
    - field
    - jsonapi
    - href_lang_exchange
    - views

### href_lang_exchange_href
- dependencies:
    - field
    - href_lang_exchange
    - country
    - languagefield


### href_lang_exchange_lang_country_override
- dependencies:
    - field
    - href_lang_exchange
    - country
    - languagefield

## Configuration

The Module Collection has 2 Entity Types.

From the href_lang_exchange_href module the site_entity which can be accessed via the
/admin/structure/site_entity/settings can be extended.
The creation of these site entities is only done on the master.
The administration page can be found under /admin/structure/site_entity.
Furthermore there is a Settings Form (/admin/structure/site_entity/basic_settings) which is not available for the Site Editor.
is meant to be. There you can set the configuration for the authentication and the url for the master server.

The second entity type is the href_lang_item which is present in the base module href_lang_exchange.
this is used to exchange the href lang information and is unintresting for the end user. To
debug or administrate can the module href_lang_entity_manager be activated it provides a view which
gives an overview of all href lang items.

## Usage

To use this module, a field of type 'Href lang exchange item' must be added to the entity.

On the master site the site entities must be created.

and now you can used the module.

## Berechtigungen

###Permission List:
- add site entity entities:
- administer site entity entities:
- delete site entity entities:
- edit site entity entities:
- view published site entity entities:
- view unpublished site entity entities:
- view all site entity revisions:
- revert all site entity revisions:
- delete all site entity revisions:
- view href_lang_item entity:
- add href_lang_item entity:
- list site entity entities
- edit href_lang_item entity:
- delete href_lang_item entity:
- administer href_lang_item entity:
- administer href-lang exchange:
### Usage
For the admin menu toolbar you need the following permissions.
 - Use the administration toolbar
 - Administer menus and menu items
 - Use the administration pages and help
------------------

For the /href_lang_item/list and all href_lang_item things
- View the administration theme:
   - To see the theme
- Administer href-lang exchange:
   - Site Access
- view href_lang_item entity:
  - To view href_lang_items
- add href_lang_item entity:
  - To add href_lang_items
- edit href_lang_item entity:
  - To edit/update href_lang_items
- delete href_lang_item entity:
  - To delete href_lang_items
------------------
For the Management of Site entieties (Administration Only)

Create new Site entities
- Delete Site entities
- Edit Site entities
- List Site entities
- View all Site revisions
- View published Site entities
- View unpublished Site entities
------------------

For real admin stuff you need this permission
- list site entity entities

## Notes
IMPORTANT: Setting the region
URL: /admin/config/regional/settings

IMPORTANT: JSON:API need CRUD Permissions
URL: admin/config/services/jsonapi


IMPORTANT: If you are on a monolingual site, please use the "default_href_lang_exchange".
The setting is under
admin/config/search/simplesitemap/variants. The following must be entered in the text field:
```
  default | default_href_lang_exchange | default
```

IMPORTANT: The following patch is required to edit the languagefield:
https://www.drupal.org/files/issues/2019-12-12/3100546-options.patch
## External Dependencies
The module collection has the following dependencies that need to be added in the composer.json so or more specifically:

        "drupal/country": "*",
        "lasserafn/php-initial-avatar-generator": "^4.0",
        "drupal/languagefield": "*",

## Simple install :

The following extensions must be installed first

composer require drupal/country:1.0.0-beta5 drupal/languagefield:1.5.0 lasserafn/php-initial-avatar-generator:4.1.1

Afterwards, the following modules must be activated under /admin/modules:

The Href Lang Base
The Site Entity Base
The Site Entity Custom Logo Extension
The Site Entity Language & Country Extension

On all pages, the write operations of jsonapi must be allowed.
/admin/config/services/jsonapi

Set on every site a default country.
/admin/config/regional/settings


Then the elements must be connected with each other.

The settings for the connection can you find under

Structure -> Sites list -> Settings

Here the url of the master must be entered e.g. https://master.bi.
This must be done on the master side as well as on the slave sides.

In addition a password must be entered with which you can be authenticated.
(Must be the same on all pages)

After that there are the options to queue the process. If these are not active, the system
execute it directly which can cause performance problems with larger constructions.

(It runs something like this: a slave creates a new element and sends it to the master (does not save it itself).
 The master then distributes it to all slaves (including the base)
|Slave 1| -> |Master| -> |[Slave 1, Slave 2]|


On the Master Site must be under

Structure -> Sites list

All slaves are entered (the master can also act as slave).


After that everything is ready to send.

Afterwards a field of type "href lang exchange item" must be added to the entity/node.

Now simply create a content and you can connect it by the href lang.


#####Optional

If you want a group instead of the flags, you have to make a field form visible in the master :

/admin/structure/site_entity/settings

The short title needs to be visible. Afterwards under

Structure -> Sites list

Add the shortname.


(For this, the options module should be activated, since it has a
 hidden dependency on the country module).
